routes/web.php
<?php



Route::get('/', 'PainelController@index')->name('Painel');
Route::Resource('includecliente', 'ClienteController');
Route::Resource('includepessoa', 'PessoaController');
Route::Resource('includeatividade', 'AtividadeController');
Route::Resource('vinculatarefas', 'TarefaController');

app/Atividade.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Atividade extends Model
{
    protected $fillable = ['titulo', 'descritivo'];
    protected $guarded = ['id', 'created_at', 'updated_at'];
    protected $table = 'atividades';

    public function Clientes(){
        return $this->belongsToMany(Cliente::class, 'tarefas');
    }
    public function Atividades(){
        return $this->belongsToMany(Atividade::class, 'tarefas');
    }
}

app/Cliente.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Cliente extends Model
{
    protected $fillable = ['nome', 'endereco'];
    protected $guarded = ['id', 'created_at', 'updated_at'];
    protected $table = 'clientes';

    public function Pessoas(){
        return $this->belongsToMany(Pessoa::class, 'tarefas');
    }
    public function Atividades(){
        return $this->belongsToMany(Atividade::class, 'tarefas');
    }
}

app/Pessoa.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Pessoa extends Model
{
    protected $fillable = ['nome', 'data_nascimento', 'clientes_id'];
    protected $guarded = ['id', 'created_at', 'updated_at'];
    protected $table = 'pessoas';
}

app/Tarefa.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Tarefa extends Model
{
    protected $fillable = ['clientes_id', 'pessoas_id', 'atividades_id'];
    protected $guarded = ['clientes_id', 'pessoas_id', 'atividades_id', 'created_at', 'updated_at'];
    protected $table = 'tarefas';

    public function Clientes(){
        return $this->belongsToMany(Cliente::class, 'tarefas');
    }

    public function Pessoas(){
        return $this->belongsToMany(Pessoa::class, 'tarefas');
    }
    public function Atividades(){
        return $this->belongsToMany(Atividade::class, 'tarefas');
    }
}

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/AtividadeController.php
<?php

namespace App\Http\Controllers;

use App\Atividade;
use Validator;
use Illuminate\Http\Request;

class AtividadeController extends Controller
{
    public function index() {
        return view('includeatividade');
    }

    public function store(Request $request) {
        $input = $request->all();

        $validator = Validator::make($input, [
            'titulo' => 'required',
            'descritivo' => 'required',
        ]);

        if($validator->fails()){
            return $this->sendError('Validation Error.', $validator->errors());
        }

        $atividades = Atividade::create($input);
        return $this->sendResponse($atividades->toArray(), 'Atividade salva com sucesso.');

    }
}

app/Http/Controllers/BaseController.php
<?php

namespace App\Http\Controllers;


use Illuminate\Http\Request;
use App\Http\Controllers\Controller as Controller;


class BaseController extends Controller
{
    /**
     * success response method.
     *
     * @return \Illuminate\Http\Response
     */
    public function sendResponse($result, $message)
    {
        $response = [
            'success' => true,
            'data'    => $result,
            'message' => $message,
        ];


        return response()->json($response, 200);
    }


    /**
     * return error response.
     *
     * @return \Illuminate\Http\Response
     */
    public function sendError($error, $errorMessages = [], $code = 404)
    {
        $response = [
            'success' => false,
            'message' => $error,
        ];


        if(!empty($errorMessages)){
            $response['data'] = $errorMessages;
        }


        return response()->json($response, $code);
    }
}

app/Http/Controllers/ClienteController.php
<?php

namespace App\Http\Controllers;

use App\Cliente;
use Illuminate\Http\Request;
use Validator;

class ClienteController extends BaseController
{
    public function index() {
        return view('includecliente');
    }

    public function store(Request $request) {
        $input = $request->all();

        $validator = Validator::make($input, [
            'nome' => 'required',
            'endereco' => 'required',
        ]);

        if($validator->fails()){
            return $this->sendError('Validation Error.', $validator->errors());
        }

        $clientes = Cliente::create($input);
        return $this->sendResponse($clientes->toArray(), 'Cliente salvo com  sucesso.');

    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/PainelController.php
<?php

namespace App\Http\Controllers;

use App\Atividade;
use App\Cliente;
use App\Pessoa;
use App\Tarefa;
use Illuminate\Http\Request;

class PainelController extends Controller
{
    public function index() {
        $tarefas = Tarefa::all();
        $clientes = Cliente::all();
        $pessoas = Pessoa::all();
        $atividades = Atividade::all();
        $total = Tarefa::all()->count();
        return view('listagem', compact( 'total', 'clientes', 'pessoas', 'atividades', 'tarefas'));
    }
}

app/Http/Controllers/PessoaController.php
<?php

namespace App\Http\Controllers;

use App\Cliente;
use App\Pessoa;
use Validator;
use Illuminate\Http\Request;

class PessoaController extends BaseController
{
    public function index() {
        $clientes = Cliente::all();
        return view('includepessoa',compact('clientes'));
    }

    public function store(Request $request) {
        $input = $request->all();

        $validator = Validator::make($input, [
            'nome' => 'required',
            'data_nascimento' => 'required',
            'clientes_id' => 'required'
        ]);

        if($validator->fails()){
            return $this->sendError('Validation Error.', $validator->errors());
        }

        $pessoas = Pessoa::create($input);
        return $this->sendResponse($pessoas->toArray(), 'Pessoa salva com  sucesso.');

    }
}

app/Http/Controllers/TarefaController.php
<?php

namespace App\Http\Controllers;

use App\Atividade;
use App\Cliente;
use App\Pessoa;
use App\Tarefa;
use Validator;
use Illuminate\Http\Request;

class TarefaController extends Controller
{
    public function index() {
        $pessoas = Pessoa::all();
        $atividades = Atividade::all();
        return view('vinculatarefas',compact('pessoas', 'atividades'));
    }

    public function store(Request $request) {
        $input = $request->all();

        $validator = Validator::make($input, [
            'pessoas_id' => 'required',
            'atividades_id' => 'required',
        ]);

        if($validator->fails()){
            return $this->sendError('Validation Error.', $validator->errors());
        }

        $pessoa = Pessoa::findOrFail($input['pessoas_id']);
        $cliente = Cliente::findOrFail($pessoa['clientes_id']);
        $data = [
            "clientes_id" => $cliente->id,
            "pessoas_id" => $input['pessoas_id'],
            "atividades_id" => $input['atividades_id'],
        ];

        $tarefa = Tarefa::updateOrCreate($data);

        return redirect()->route('vinculatarefas.index')->with('message', 'Tarefa criada com sucesso!');
    }
}

resources/views/footer.blade.php
    <!-- JavaScript -->
    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js"></script>
</body>

</html>

resources/views/header.blade.php
<!DOCTYPE html>
<html lang="pt-br">

<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <title>Painel</title>

    <!-- Favicon -->
    <link href="{{URL::asset('img/favicon.ico')}}" rel="shortcut icon">

    <!-- Fonts -->
    <link href="https://fonts.googleapis.com/css?family=Raleway:100,600" rel="stylesheet" type="text/css">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.5.0/css/font-awesome.min.css">

    <!-- Styles -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css">
    <link href="{{URL::asset('css/style.css')}}" rel="stylesheet" type="text/css" />
</head>

<body>
    <div class="row">
        <div class="col-12">
        <nav class="navbar navbar-expand-md navbar-light menu-painel">
            <a class="navbar-brand" href="{{url('/')}}"></a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#conteudoNavbarSuportado" aria-controls="conteudoNavbarSuportado" aria-expanded="false" aria-label="Alterna navegação">
                <span class="navbar-toggler-icon"></span>
            </button>
    
            <div class="collapse navbar-collapse" id="conteudoNavbarSuportado">
                <ul class="navbar-nav mr-auto">
                    <li class="nav-item">
                        <a class="nav-link" href="{{url('/')}}">Home <span class="sr-only">(página atual)</span></a>
                    </li>
                    <li class="nav-item dropdown">
                        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                            Cadastros
                        </a>
                        <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                            <a class="dropdown-item" href="{{route('includecliente.index')}}">Cadastrar Cliente</a>
                            <a class="dropdown-item" href="{{route('includepessoa.index')}}">Cadastrar Pessoa</a>
                            <a class="dropdown-item" href="{{route('includeatividade.index')}}">Cadastrar Atividade</a>
                            <a class="dropdown-item" href="{{route('vinculatarefas.index')}}">Vincular Tarefas</a>
                        </div>
                    </li>
                </ul>
            </div>
        </nav>
        </div>
        

    </div>

resources/views/includeatividade.blade.php
@include('header')
<div class="container">
    <div class="row">
        <div class="col-12">
            <div class="jumbotron text-center">
                <h1 class="display-4"><b>Incluir</b></h1>
            </div>
        </div>
    </div>
    @if (session('message'))
        <div class="alert alert-success alert-dismissible">
            <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
            {{ session('message') }}
        </div>
    @endif
    <div class="row">
        <div class="col-12">
            <nav aria-label="breadcrumb">
                <ol class="breadcrumb">
                    <li class="breadcrumb-item"><a href="{{url('/')}}">Listagem</a></li>
                    <li class="breadcrumb-item active" aria-current="page">Incluir</li>
                </ol>
            </nav>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <h4 class="text-center"><b>CADASTRO DE ATIVIDADE</b></h4>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <form method="post" action="{{route('includeatividade.store')}}" enctype="multipart/form-data">
                {{ csrf_field() }}


                <div class="row">
                    <div class="col-6">
                        <div class="form-group">
                            <label for="titulo">Título</label>
                            <input type="text" name="titulo" class="form-control" required>
                        </div>
                    </div>
                    <div class="col-6">
                        <div class="form-group">
                            <label for="descritivo">Descritivo</label>
                            <input type="text" name="descritivo" class="form-control" required>
                        </div>
                    </div>
                </div>

                @if ($errors->any())
                    <div class="row">

                        <div class="offset-md-6 col-6">
                            <div class="alert alert-danger">
                                <ul>
                                    @foreach ($errors->all() as $error)
                                        <li>{{ $error }}</li>
                                    @endforeach
                                </ul>
                            </div>
                        </div>
                    </div>
                @endif
                <div class="row">
                    <div class="col-3 offset-md-9">
                        <button type="reset" class="btn btn-default">
                            Limpar
                        </button>
                        <button type="submit" class="btn btn-warning" id="black">
                            Cadastrar
                        </button>
                    </div>
                </div>

            </form>
        </div>
    </div>
    <div class="clear"></div>
</div>
@include('footer')

resources/views/includecliente.blade.php
@include('header')
<div class="container">
    <div class="row">
        <div class="col-12">
            <div class="jumbotron text-center">
                <h1 class="display-4"><b>Incluir</b></h1>
            </div>
        </div>
    </div>
@if (session('message'))
    <div class="alert alert-success alert-dismissible">
        <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
        {{ session('message') }}
    </div>
@endif
    <div class="row">
        <div class="col-12">
            <nav aria-label="breadcrumb">
                <ol class="breadcrumb">
                    <li class="breadcrumb-item"><a href="{{url('/')}}">Listagem</a></li>
                    <li class="breadcrumb-item active" aria-current="page">Incluir</li>
                </ol>
            </nav>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <h4 class="text-center"><b>CADASTRO DE CLIENTE</b></h4>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <form method="post" action="{{route('includecliente.store')}}" enctype="multipart/form-data">
                {{ csrf_field() }}


                <div class="row">
                    <div class="col-6">
                        <div class="form-group">
                            <label for="nome">Nome</label>
                            <input type="text" name="nome" class="form-control" required>
                        </div>
                    </div>
                    <div class="col-6">
                        <div class="form-group">
                            <label for="endereco">Endereço</label>
                            <input type="text" name="endereco" class="form-control" required>
                        </div>
                    </div>
                </div>

                @if ($errors->any())
                    <div class="row">

                        <div class="offset-md-6 col-6">
                            <div class="alert alert-danger">
                                <ul>
                                    @foreach ($errors->all() as $error)
                                        <li>{{ $error }}</li>
                                    @endforeach
                                </ul>
                            </div>
                        </div>
                    </div>
                @endif
                <div class="row">
                    <div class="col-3 offset-md-9">
                        <button type="reset" class="btn btn-default">
                            Limpar
                        </button>
                        <button type="submit" class="btn btn-warning" id="black">
                            Cadastrar
                        </button>
                    </div>
                </div>

            </form>
        </div>
    </div>
    <div class="clear"></div>
</div>
@include('footer')

resources/views/includepessoa.blade.php
@include('header')
<div class="container">
    <div class="row">
        <div class="col-12">
            <div class="jumbotron text-center">
                <h1 class="display-4"><b>Incluir</b></h1>
            </div>
        </div>
    </div>
    @if (session('message'))
        <div class="alert alert-success alert-dismissible">
            <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
            {{ session('message') }}
        </div>
    @endif
    <div class="row">
        <div class="col-12">
            <nav aria-label="breadcrumb">
                <ol class="breadcrumb">
                    <li class="breadcrumb-item"><a href="{{url('/')}}">Listagem</a></li>
                    <li class="breadcrumb-item active" aria-current="page">Incluir</li>
                </ol>
            </nav>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <h4 class="text-center"><b>CADASTRO DE PESSOA</b></h4>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <form method="post" action="{{route('includepessoa.store')}}" enctype="multipart/form-data">
                {{ csrf_field() }}
                <div class="row">
                    <div class="col-12">
                        <div class="form-group">
                            <label for="clientes_id">Clientes</label>
                            <select name="clientes_id" class="form-control" id="clientes_id">
                                @foreach($clientes as $clientes_item)
                                    <option value="{{$clientes_item['id']}}">{{$clientes_item['nome']}}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-6">
                        <div class="form-group">
                            <label for="nome">Nome</label>
                            <input type="text" name="nome" class="form-control" required>
                        </div>
                    </div>
                    <div class="col-6">
                        <div class="form-group">
                            <label for="data_nascimento">Data de Nascimento</label>
                            <input type="date" name="data_nascimento" class="form-control" required>
                        </div>
                    </div>
                </div>


                @if ($errors->any())
                    <div class="row">

                        <div class="offset-md-6 col-6">
                            <div class="alert alert-danger">
                                <ul>
                                    @foreach ($errors->all() as $error)
                                        <li>{{ $error }}</li>
                                    @endforeach
                                </ul>
                            </div>
                        </div>
                    </div>
                @endif
                <div class="row">
                    <div class="col-3 offset-md-9">
                        <button type="reset" class="btn btn-default">
                            Limpar
                        </button>
                        <button type="submit" class="btn btn-warning" id="black">
                            Cadastrar
                        </button>
                    </div>
                </div>

            </form>
        </div>
    </div>
    <div class="clear"></div>
</div>
@include('footer')

resources/views/listagem.blade.php
@include('header')

<div class="container">
    <div class="col-12">
        <div class="jumbotron text-center">
            <h1 class="display-4"><b>Colaboradores com tarefas</b></h1>
        </div>
    </div>
    @if (session('message'))
    <div class="alert alert-success alert-dismissible">
        <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
        {{ session('message') }}
    </div>
    @endif
    <div class="col-12">
        <nav aria-label="breadcrumb">
            <ol class="breadcrumb">
                <li class="breadcrumb-item active" aria-current="page">Listagem</li>
            </ol>
        </nav>
    </div>
    <div class="col-12">
        <h4 class="text-center"><b>LISTAGEM DE COLABORADORES COM TAREFAS ({{$total}})</b></h4>
    </div>
    <div class="col-md-2 offset-md-10">
        <a class="btn btn-light" href="{{route('vinculatarefas.index')}}" class="btn btn-default btn-sm pull-right">
            <span class="fa fa-plus"></span> Adicionar</a>
    </div>
    <div class="table-responsive">
        <table class="table table-striped">
            <thead>
                <tr>
                    <th>Clientes</th>
                    <th>Pessoas</th>
                    <th>Atividades</th>
                </tr>
            </thead>
            <tbody>
            @foreach($tarefas as $tarefa)
                <tr>
                    @foreach($clientes as $cliente_item)
                        @if($tarefa->clientes_id == $cliente_item['id'])
                            <td>{{$cliente_item['nome']}}</td>
                        @endif
                    @endforeach
                    @foreach($pessoas as $pessoa_item)
                        @if($tarefa->pessoas_id == $pessoa_item['id'])
                            <td>{{$pessoa_item['nome']}}</td>
                        @endif
                    @endforeach
                    @foreach($atividades as $atividade_item)
                        @if($tarefa->atividades_id == $atividade_item['id'])
                            <td>{{$atividade_item['titulo']}}</td>
                        @endif
                    @endforeach
                </tr>
            @endforeach
            </tbody>
        </table>
    </div>
    <div class="clear"></div>
</div>
@include('footer')

resources/views/vinculatarefas.blade.php
@include('header')
<div class="container">
    <div class="row">
        <div class="col-12">
            <div class="jumbotron text-center">
                <h1 class="display-4"><b>Incluir</b></h1>
            </div>
        </div>
    </div>
    @if (session('message'))
        <div class="alert alert-success alert-dismissible">
            <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
            {{ session('message') }}
        </div>
    @endif
    <div class="row">
        <div class="col-12">
            <nav aria-label="breadcrumb">
                <ol class="breadcrumb">
                    <li class="breadcrumb-item"><a href="{{url('/')}}">Listagem</a></li>
                    <li class="breadcrumb-item active" aria-current="page">Incluir</li>
                </ol>
            </nav>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <h4 class="text-center"><b>VINCULAR TAREFAS</b></h4>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <form method="post" action="{{route('vinculatarefas.store')}}" enctype="multipart/form-data">
                {{ csrf_field() }}
                <div class="row">
                    <div class="col-6">
                        <div class="form-group">
                            <label for="pessoas_id">Pessoas</label>
                            <select name="pessoas_id" class="form-control" id="pessoas_id">
                                @foreach($pessoas as $pessoas_item)
                                    <option value="{{$pessoas_item['id']}}">{{$pessoas_item['nome']}}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>
                    <div class="col-6">
                        <div class="form-group">
                            <label for="atividades_id">Atividades</label>
                            <select name="atividades_id" class="form-control" id="atividades_id">
                                @foreach($atividades as $atividades_item)
                                    <option value="{{$atividades_item['id']}}">{{$atividades_item['titulo']}}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>
                </div>

                @if ($errors->any())
                    <div class="row">

                        <div class="offset-md-6 col-6">
                            <div class="alert alert-danger">
                                <ul>
                                    @foreach ($errors->all() as $error)
                                        <li>{{ $error }}</li>
                                    @endforeach
                                </ul>
                            </div>
                        </div>
                    </div>
                @endif
                <div class="row">
                    <div class="col-3 offset-md-9">
                        <button type="reset" class="btn btn-default">
                            Limpar
                        </button>
                        <button type="submit" class="btn btn-warning" id="black">
                            Cadastrar
                        </button>
                    </div>
                </div>

            </form>
        </div>
    </div>
    <div class="clear"></div>
</div>
@include('footer')